$dirsep = "\\" #Windows
class Qvoronoi
	def Qvoronoi::mesh
#		qfile=File.dirname(__FILE__)+$dirsep+"qhull"+$dirsep+"qhull.exe"
#		qfile=qfile.gsub('/',$dirsep)
#		qcom=qfile + " TI qhull"+$dirsep+"points.txt"
#		qmethod=" v Qbb Qj"
#		qparams=" o Fv"
#		qexport=" TO qhull"+$dirsep+"qvoronoi.txt"

		#output to file
#		system(qcom + qmethod + qparams + qexport)
		
		points_file_path=File.dirname(__FILE__)+$dirsep+"qhull"+$dirsep+"qvoronoi.txt"
		points=File.new(points_file_path.to_s,"r") #opens the input file
	  table_lines = IO.readlines(points_file_path.to_s)
		dimensions = table_lines[0].to_i
		numbers = table_lines[1].split
		
		vertices_startline = 2
		number_of_vertices = numbers[0].to_i

		regions_startline = vertices_startline+number_of_vertices
		number_of_regions = numbers[1].to_i
		
		faces_startline = regions_startline + number_of_regions
		number_of_faces = table_lines[faces_startline].to_i

		group_ridges = 0
		
		#(table_lines.length-1)/2-1
	  #UI.messagebox(number_of_vertices.to_s + " points to import, faces:" + number_of_regions.to_s )

		Sketchup.active_model.start_operation "Build Voronoi"
			facelayer=Sketchup.active_model.layers.add("Voronoi")
			facelayer.visible=true
				
			#UI.messagebox "Vstart: " + vertices_startline.to_s +  "Vno: " + number_of_vertices.to_s + "Rstart: " + regions_startline.to_s + "Rno: " + number_of_regions.to_s + "Fstart: " + faces_startline.to_s + "Fno: " + number_of_faces.to_s

			#UI.messagebox table_lines[startline]
			#return nil
			startline = faces_startline
			number_ents = number_of_faces
			0.upto(number_ents-1) do |i|
				facepoints = table_lines[i+startline].split
				ptf = []
				current_point = []
				removepoint = 0
				
				#facelayer=Sketchup.active_model.layers.add("voronoi " + i.to_s)
				#facelayer.visible=true

				facegroup = Sketchup.active_model.active_entities.add_group
				facegroup.name = "voronoi " + i.to_s
				
				indice_pair = []
				
				facepoints.delete_at(0) #removes the first item specifying the number of face verticies
				indice_pair[0] = facepoints.delete_at(0)	#reads and then removes information about the FIRST ridge neighbour
				indice_pair[1] = facepoints.delete_at(0)	#reads and then removes information about the SECOND ridge neighbour
				#UI.messagebox indice_pair.to_s
				if(facepoints[0].to_i==0)then #first point is an infinite so lets reverse the current face vertices
					facepoints = facepoints.reverse
				end
				#UI.messagebox facepoints.to_s
				0.upto(facepoints.length-1) do |j|
					if facepoints[j].to_i <= number_of_vertices then
						if facepoints[j].to_i > 0 then
							current_point = table_lines[facepoints[j].to_i+2].split
							x = (current_point[0].to_f.to_l)
							y = (current_point[1].to_f.to_l)
							if(dimensions == 3) then
								z = (current_point[2].to_f.to_l)
							else
								z = 0.to_f
							end
							ptf[j-removepoint] = Geom::Point3d.new(x,y,z)
						elsif facepoints[j].to_i == 0 then	#try to look for the infinite coordinate
							#ptf[j-removepoint] = Geom::Point3d.new(0,0,0)
							removepoint = removepoint + 1
						else
							#remove invalid coordinate
							removepoint = removepoint + 1
						end
					else 
						removepoint = removepoint + 1
					end
				end
				stepbystep = 0
				#stepbystep = UI.messagebox "Do you want to construct Face: " + (i+1).to_s + ", press No to skip.", MB_YESNOCANCEL, "Proceed"
				if stepbystep == 2
					return nil
				end
				if(stepbystep == 6 or stepbystep == 0) then #when the answer is yes
					#if (ptf.length != 3) then
						#UI.messagebox "create line"
						#UI.messagebox i.to_s + ": " + ptf.length.to_s + "   >" + ptf.to_s
						0.upto(ptf.length-1) do |point|
							firstlast_edge = []
							firstlast_edge[0] = ptf[point]
							if(point == (ptf.length-1)) then
								#UI.messagebox "last point (" + point.to_s + ") of this region"
								firstlast_edge[1] = ptf[0]
							else
								firstlast_edge[1] = ptf[point+1]
							end
							if(group_ridges == 1) then
								drawedges = facegroup.entities.add_edges(firstlast_edge)
								if drawedges
									drawedges.each{|e| e.layer=facelayer}
								end
								#facegroup.entities.add_text i.to_s + ":" + point.to_s,firstlast_edge[0]
							else
								drawedges = Sketchup.active_model.active_entities.add_edges(firstlast_edge)
									if drawedges
										drawedges.each{|e| e.layer=facelayer}
									end
								if(ptf.length > 2) then
									ridgeface = Sketchup.active_model.active_entities.add_face(ptf)
									ridgeface.layer=facelayer
								end
								#Sketchup.active_model.active_entities.add_text i.to_s + ":" + point.to_s,firstlast_edge[0]
							end
						end
				#else
					#UI.messagebox "create plane"
					#UI.messagebox i.to_s + ": " + ptf.length.to_s + "   >" + ptf.to_s
					#Sketchup.active_model.active_entities.add_face(ptf)
				end	
			end
		Sketchup.active_model.commit_operation
	end #def
end #class
if( not $tooling_sub_menu )
	$tooling_sub_menu = UI.menu("Plugins").add_submenu("Qhull")
end
if( not $qvoronoi_menu_loaded )
	$tooling_sub_menu.add_item("Voronoi") { Qvoronoi.mesh }
	$qvoronoi_menu_loaded = true
end